var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import CRC32C from "crc-32/crc32c";
import base64 from "base-64";
var GCSResumableUpload = /** @class */ (function () {
    function GCSResumableUpload(sessionURI, localFile) {
        this.sessionURI = sessionURI;
        this.localFile = localFile;
        this.onProgressHandlers = [];
        this.onStateChangeHandlers = [];
        // this.abortController = new AbortController();
        // this.isStarted = false;
        // this.isCancelled = false;
        this.currentState = "NOT_STARTED";
        this.currentProgress = 0;
        this.xhr = null;
        this.crc32cb64 = null;
    }
    GCSResumableUpload.prototype.calculateChecksum = function () {
        return __awaiter(this, void 0, void 0, function () {
            var buf, arr, chksum, fixedChksum, chksumHex, dataBuf, i, b64crc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.localFile.arrayBuffer()];
                    case 1:
                        buf = _a.sent();
                        arr = new Uint8Array(buf);
                        chksum = CRC32C.buf(arr);
                        fixedChksum = chksum;
                        if (fixedChksum < 0) {
                            // First bit is sign bit
                            // fixedChksum = (chksum * -1) + Math.pow(2, 31);
                            // But really it's 2s complement signed
                            fixedChksum = chksum + Math.pow(2, 32);
                        }
                        chksumHex = fixedChksum.toString(16);
                        dataBuf = "";
                        for (i = 0; i < chksumHex.length; i++) {
                            dataBuf += !(i - 1 & 1) ? String.fromCharCode(parseInt(chksumHex.substring(i - 1, i + 1), 16)) : "";
                        }
                        b64crc = base64.encode(dataBuf);
                        this.crc32cb64 = b64crc;
                        console.log("CRC32C is: " + b64crc + " (" + chksumHex + ")");
                        return [2 /*return*/];
                }
            });
        });
    };
    GCSResumableUpload.prototype.cancel = function () {
        if (this.currentState !== "CANCELLED") {
            this.fireNewState("CANCELLED");
            if (this.xhr !== null) {
                this.xhr.abort();
            }
            // this.abortController.abort();
        }
    };
    GCSResumableUpload.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            var finalState, maxReadTime, maxBufferSize, buffers_1, bufferSize_1, offset_1, startMs, flushBuffer, stream, reader, _a, done, value, nowMs, age, flush, chunksize, offset, chunkfile, chunk, chunk, status_1, e_1;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.currentState !== "NOT_STARTED") {
                            throw new Error("Started already");
                        }
                        // This step is required for consistancy checks
                        return [4 /*yield*/, this.calculateChecksum()];
                    case 1:
                        // This step is required for consistancy checks
                        _b.sent();
                        this.fireNewState("UPLOADING");
                        finalState = ["CANCELLED", "FAILED", "SUCCESSFUL"];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 20, , 21]);
                        console.log("TODO, prepare and do the upload", this.localFile);
                        if (!this.localFile.stream) return [3 /*break*/, 9];
                        console.log("Using File Stream");
                        maxReadTime = 1000;
                        maxBufferSize = 8 * 1024 * 1024;
                        buffers_1 = [];
                        bufferSize_1 = 0;
                        offset_1 = 0;
                        startMs = (new Date()).getTime();
                        flushBuffer = function (isFinal) { return __awaiter(_this, void 0, void 0, function () {
                            var newBufferSize, chunk256, max256Size, concatBuffer, bufOffset, recycledBuffers, recycledSize, _i, buffers_2, buf_1, remaining, useData, recycleData;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!(bufferSize_1 > 0)) return [3 /*break*/, 2];
                                        newBufferSize = bufferSize_1;
                                        if (!isFinal) {
                                            chunk256 = Math.floor(bufferSize_1 / (256 * 1024));
                                            max256Size = chunk256 * 256 * 1024;
                                            console.log("Buffer size", bufferSize_1, "so chunk should be " + chunk256 + " * 256K ", max256Size);
                                            newBufferSize = max256Size;
                                        }
                                        concatBuffer = new Uint8Array(newBufferSize);
                                        bufOffset = 0;
                                        recycledBuffers = [];
                                        recycledSize = 0;
                                        for (_i = 0, buffers_2 = buffers_1; _i < buffers_2.length; _i++) {
                                            buf_1 = buffers_2[_i];
                                            if (!isFinal && bufOffset === newBufferSize) {
                                                // console.log("Already at correct size");
                                                // Already at the correct size, recycle buffer
                                                recycledBuffers.push(buf_1);
                                                recycledSize += buf_1.byteLength;
                                            }
                                            else {
                                                // console.log("There is more space, fill up using next buffer");
                                                // Is this next buffer going to breach the max size?
                                                if (!isFinal && (buf_1.byteLength + bufOffset) > newBufferSize) {
                                                    remaining = newBufferSize - bufOffset;
                                                    useData = buf_1.slice(0, remaining);
                                                    recycleData = buf_1.slice(remaining);
                                                    concatBuffer.set(new Uint8Array(useData), bufOffset);
                                                    bufOffset += useData.byteLength;
                                                    // Don't forget to recycle the non used section
                                                    recycledBuffers.push(recycleData);
                                                    recycledSize += recycleData.byteLength;
                                                }
                                                else {
                                                    // Use the whole buffer
                                                    // console.log("Using the whole buffer " + buf.byteLength + " total is " + bufOffset + "/" + newBufferSize);
                                                    concatBuffer.set(new Uint8Array(buf_1), bufOffset);
                                                    bufOffset += buf_1.byteLength;
                                                }
                                            }
                                        }
                                        // Clean the buffers
                                        buffers_1 = recycledBuffers;
                                        bufferSize_1 = recycledSize;
                                        // console.log("Recycling " + bufferSize + " bytes for next chunk");
                                        // Handle the large chunk
                                        return [4 /*yield*/, this.handleChunk(offset_1, concatBuffer)];
                                    case 1:
                                        // console.log("Recycling " + bufferSize + " bytes for next chunk");
                                        // Handle the large chunk
                                        _a.sent();
                                        if (finalState.indexOf(this.currentState) === -1) {
                                            offset_1 += concatBuffer.byteLength;
                                            // console.log("Handled " + offset + " of " + this.localFile.size + " total bytes");
                                        }
                                        _a.label = 2;
                                    case 2: return [2 /*return*/];
                                }
                            });
                        }); };
                        stream = this.localFile.stream();
                        reader = stream.getReader();
                        _b.label = 3;
                    case 3:
                        if (!true) return [3 /*break*/, 7];
                        return [4 /*yield*/, reader.read()];
                    case 4:
                        _a = _b.sent(), done = _a.done, value = _a.value;
                        if (done) {
                            return [3 /*break*/, 7];
                        }
                        nowMs = (new Date()).getTime();
                        age = nowMs - startMs;
                        buffers_1.push(new Uint8Array(value));
                        bufferSize_1 += value.byteLength;
                        flush = false;
                        if (bufferSize_1 > maxBufferSize) {
                            // Send this as a single chunk
                            // console.log("Buffer max size breached, flushing...");
                            flush = true;
                        }
                        else if (age > maxReadTime) {
                            // console.log("Max read time breached, flushing...");
                            flush = true;
                        }
                        if (!flush) return [3 /*break*/, 6];
                        return [4 /*yield*/, flushBuffer(false)];
                    case 5:
                        _b.sent();
                        startMs = (new Date()).getTime(); // Reset the timer so we count from 0 again
                        _b.label = 6;
                    case 6:
                        if (finalState.indexOf(this.currentState) !== -1) {
                            return [2 /*return*/];
                        }
                        return [3 /*break*/, 3];
                    case 7:
                        if (finalState.indexOf(this.currentState) !== -1) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, flushBuffer(true)];
                    case 8:
                        _b.sent();
                        return [3 /*break*/, 18];
                    case 9:
                        console.log("Old browser, using manual chunking");
                        chunksize = 8 * 1024 * 1024;
                        offset = 0;
                        _b.label = 10;
                    case 10:
                        if (!(offset < this.localFile.size)) return [3 /*break*/, 18];
                        return [4 /*yield*/, this.localFile.slice(offset, offset + chunksize)];
                    case 11:
                        chunkfile = _b.sent();
                        if (!chunkfile.arrayBuffer) return [3 /*break*/, 14];
                        return [4 /*yield*/, chunkfile.arrayBuffer()];
                    case 12:
                        chunk = _b.sent();
                        return [4 /*yield*/, this.handleChunk(offset, chunk)];
                    case 13:
                        _b.sent();
                        return [3 /*break*/, 17];
                    case 14: return [4 /*yield*/, new Response(chunkfile).arrayBuffer()];
                    case 15:
                        chunk = _b.sent();
                        return [4 /*yield*/, this.handleChunk(offset, chunk)];
                    case 16:
                        _b.sent();
                        _b.label = 17;
                    case 17:
                        offset += chunksize;
                        if (finalState.indexOf(this.currentState) !== -1) {
                            return [2 /*return*/];
                        }
                        return [3 /*break*/, 10];
                    case 18:
                        if (finalState.indexOf(this.currentState) !== -1) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.getUploadStatus()];
                    case 19:
                        status_1 = _b.sent();
                        if (status_1.complete) {
                            this.finalDataStored(status_1.response.crc32, parseInt(status_1.response.size));
                        }
                        else {
                            throw new Error("We've finished uploading data, but status isnt returning as complete");
                        }
                        return [3 /*break*/, 21];
                    case 20:
                        e_1 = _b.sent();
                        console.error(e_1);
                        console.log("Error caught");
                        this.fireNewState("FAILED");
                        return [3 /*break*/, 21];
                    case 21: return [2 /*return*/];
                }
            });
        });
    };
    GCSResumableUpload.prototype.handleChunk = function (offset, buffer) {
        return __awaiter(this, void 0, void 0, function () {
            var finalState, _loop_1, this_1, state_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        finalState = ["CANCELLED", "FAILED", "SUCCESSFUL"];
                        _loop_1 = function () {
                            var chunkSize, chunkStart, chunkStop, headers, endByte, result, isLastRequest, responseData, status_2, re, matches, lastByte, lastByteOfChunk, newBuffer, newOffset, e_2;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        chunkSize = buffer.byteLength;
                                        chunkStart = offset;
                                        chunkStop = offset + chunkSize - 1;
                                        headers = {
                                            "Content-Length": chunkSize.toString(),
                                            "Content-Range": "bytes " + chunkStart + "-" + chunkStop + "/" + this_1.localFile.size,
                                        };
                                        endByte = offset + buffer.byteLength;
                                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                                var xhr = new XMLHttpRequest();
                                                _this.xhr = xhr;
                                                xhr.upload.addEventListener("progress", function (event) {
                                                    if (event.lengthComputable) {
                                                        console.log("upload progress:", event.loaded, event.total);
                                                        _this.logUploadProgress(offset + event.loaded, _this.localFile.size);
                                                    }
                                                });
                                                /*
                                                xhr.addEventListener("progress", (event) => {
                                                if (event.lengthComputable) {
                                                    console.log("download progress:", event.loaded / event.total);
                                                }
                                                });
                                                */
                                                xhr.addEventListener("loadend", function () {
                                                    if (xhr.readyState === 4) {
                                                        _this.xhr = null;
                                                        resolve({
                                                            status: xhr.status,
                                                            statusText: xhr.statusText,
                                                            data: xhr.responseText,
                                                        });
                                                    }
                                                });
                                                xhr.addEventListener("error", function (event) {
                                                    // Something went wrong, retry
                                                    console.warn(event);
                                                    _this.xhr = null;
                                                    resolve({
                                                        status: 0,
                                                        statusText: event.type,
                                                        data: "",
                                                    });
                                                });
                                                xhr.addEventListener("timeout", function () {
                                                    // Timed out, retry
                                                    console.warn("Timeout detected");
                                                    _this.xhr = null;
                                                    resolve({
                                                        status: 0,
                                                        statusText: "Timed out",
                                                        data: "",
                                                    });
                                                });
                                                xhr.addEventListener("abort", function () {
                                                    // Abort detected, retry
                                                    console.warn("Abort detected");
                                                    _this.xhr = null;
                                                    resolve({
                                                        status: 0,
                                                        statusText: "Aborted",
                                                        data: "",
                                                    });
                                                });
                                                xhr.open("PUT", _this.sessionURI, true);
                                                xhr.setRequestHeader("Content-Range", headers["Content-Range"]);
                                                // Note: This is a good way to simulate disconnect during development.
                                                // Upload for a bit, then timeout and it should retry and fetch status
                                                // We shouldn't set timeout in production because we dont know how long the upload will take
                                                // xhr.timeout = 500;
                                                // xhr.timeout = 60 * 1000; // 1 minute max upload to avoid pending bugs
                                                xhr.send(buffer);
                                            })];
                                    case 1:
                                        result = _b.sent();
                                        if (!(result.status === 308)) return [3 /*break*/, 2];
                                        return [2 /*return*/, { value: void 0 }];
                                    case 2:
                                        if (!(result.status == 200 || result.status === 201)) return [3 /*break*/, 3];
                                        isLastRequest = (chunkStop + 1) === this_1.localFile.size;
                                        if (isLastRequest) {
                                            responseData = JSON.parse(result.data);
                                            this_1.finalDataStored(responseData.crc32c, parseInt(responseData.size));
                                        }
                                        return [2 /*return*/, { value: void 0 }];
                                    case 3:
                                        if (!(result.status >= 400 && result.status <= 499)) return [3 /*break*/, 4];
                                        // Non recoverable
                                        throw new Error("Non recoverable status " + result.status + ": " + result.statusText);
                                    case 4:
                                        console.log("AUTO RECOVERY NEEDED HERE");
                                        console.log("Status of PUT was", result.status, result.statusText);
                                        console.log("OUTPUT OF PUT WAS", result.data);
                                        _b.label = 5;
                                    case 5:
                                        if (!true) return [3 /*break*/, 11];
                                        console.log(new Date(), "BACKOFF...");
                                        this_1.fireNewState("BACKOFF");
                                        return [4 /*yield*/, this_1.backOff()];
                                    case 6:
                                        _b.sent(); // Pause for appropriate amount of time and retry
                                        // Check for a final state here
                                        if (finalState.indexOf(this_1.currentState) !== -1) {
                                            console.log("We are in a final state, stopping...");
                                            return [2 /*return*/, { value: void 0 }];
                                        }
                                        _b.label = 7;
                                    case 7:
                                        _b.trys.push([7, 9, , 10]);
                                        console.log("Resuming the upload by checking the status...");
                                        return [4 /*yield*/, this_1.getUploadStatus()];
                                    case 8:
                                        status_2 = _b.sent();
                                        if (status_2.complete) {
                                            // Whole upload looks completed, not just this chunk
                                            this_1.finalDataStored(status_2.response.crc32c, parseInt(status_2.response.size));
                                            return [2 /*return*/, { value: void 0 }];
                                        }
                                        else {
                                            // Need to do more uploading
                                            console.log("We need to do more uploading...", status_2.range);
                                            if (status_2.range) {
                                                re = new RegExp("^bytes=0\-(\\d+)$");
                                                matches = re.exec(status_2.range);
                                                if (matches) {
                                                    lastByte = parseInt(matches[1], 10);
                                                    if (lastByte >= endByte) {
                                                        // The service has more bytes already than this chunk represents
                                                        // Just continue
                                                        this_1.fireNewState("UPLOADING");
                                                        return [2 /*return*/, { value: void 0 }];
                                                    }
                                                    else if (lastByte > offset) {
                                                        lastByteOfChunk = lastByte - offset;
                                                        newBuffer = buffer.slice(lastByteOfChunk);
                                                        newOffset = lastByte;
                                                        console.log("Sliced buffer from " + buffer.byteLength + " to " + newBuffer.byteLength + " because GCS has everything until " + lastByteOfChunk);
                                                        buffer = newBuffer;
                                                        offset = newOffset;
                                                    }
                                                }
                                            }
                                        }
                                        return [3 /*break*/, 11];
                                    case 9:
                                        e_2 = _b.sent();
                                        console.warn(e_2);
                                        console.warn("Couldnt resume upload");
                                        return [3 /*break*/, 10];
                                    case 10: return [3 /*break*/, 5];
                                    case 11:
                                        this_1.fireNewState("UPLOADING");
                                        _b.label = 12;
                                    case 12: return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 3];
                        return [5 /*yield**/, _loop_1()];
                    case 2:
                        state_1 = _a.sent();
                        if (typeof state_1 === "object")
                            return [2 /*return*/, state_1.value];
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    GCSResumableUpload.prototype.finalDataStored = function (crc32c, fileSize) {
        if (this.crc32cb64 === crc32c && this.localFile.size === fileSize) {
            // Success
            this.fireNewState("SUCCESSFUL");
        }
        else {
            // Failed
            console.warn("Expecting B64 CRC32C: " + this.crc32cb64 + " of size " + this.localFile.size + " but google reported " + crc32c + " of size " + fileSize);
            this.fireNewState("FAILED");
        }
    };
    GCSResumableUpload.prototype.getUploadStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result, responseData;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log("Fetching upload status...");
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                var xhr = new XMLHttpRequest();
                                _this.xhr = xhr;
                                xhr.addEventListener("loadend", function () {
                                    if (xhr.readyState === 4) {
                                        _this.xhr = null;
                                        resolve({
                                            status: xhr.status,
                                            statusText: xhr.statusText,
                                            data: xhr.responseText,
                                            range: xhr.getResponseHeader("range"),
                                        });
                                    }
                                });
                                xhr.addEventListener("error", function (event) {
                                    // Something went wrong, retry
                                    console.warn(event);
                                    _this.xhr = null;
                                    resolve({
                                        status: 0,
                                        statusText: event.type,
                                        data: "",
                                        range: "",
                                    });
                                });
                                xhr.addEventListener("timeout", function () {
                                    // Timed out, retry
                                    console.warn("Timeout detected");
                                    _this.xhr = null;
                                    resolve({
                                        status: 0,
                                        statusText: "Timed out",
                                        data: "",
                                        range: "",
                                    });
                                });
                                xhr.addEventListener("abort", function () {
                                    // Abort detected, retry
                                    console.warn("Abort detected");
                                    _this.xhr = null;
                                    resolve({
                                        status: 0,
                                        statusText: "Aborted",
                                        data: "",
                                        range: "",
                                    });
                                });
                                xhr.open("PUT", _this.sessionURI, true);
                                // Origin is not controllable
                                // xhr.setRequestHeader("Origin", document.location.origin);
                                // xhr.setRequestHeader("content-type", "");
                                xhr.setRequestHeader("Content-Range", "bytes */" + _this.localFile.size);
                                xhr.timeout = 10 * 1000; // Check status shouldn't take longer than 10 seconds
                                xhr.send(); // Send 0 bytes
                            })];
                    case 1:
                        result = _a.sent();
                        console.log("Upload status response: " + result.status + " " + result.statusText);
                        if (result.status === 200 || result.status === 201) {
                            responseData = JSON.parse(result.data);
                            return [2 /*return*/, {
                                    complete: true,
                                    response: responseData,
                                }];
                        }
                        else if (result.status === 308) {
                            return [2 /*return*/, {
                                    complete: false,
                                    range: result.range,
                                }];
                        }
                        else {
                            throw new Error("Unknown response from status: " + result.status + " " + result.statusText);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    GCSResumableUpload.prototype.backOff = function () {
        return __awaiter(this, void 0, void 0, function () {
            var delayMs;
            return __generator(this, function (_a) {
                delayMs = 10 * 1000;
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        setTimeout(function () {
                            resolve();
                        }, delayMs);
                    })];
            });
        });
    };
    GCSResumableUpload.prototype.logUploadProgress = function (bytesSent, bytesTotal) {
        // Only fire events if the rounded percentage point is different to the current one
        var perthouDone = Math.floor((bytesSent / bytesTotal) * 1000);
        if (perthouDone !== this.currentProgress) {
            this.currentProgress = perthouDone; // Store perthou 1/1000
            this.fireProgress(perthouDone / 10); // But fire percent value
        }
    };
    GCSResumableUpload.prototype.onProgress = function (handler) {
        this.onProgressHandlers.push(handler);
    };
    GCSResumableUpload.prototype.fireProgress = function (progress) {
        for (var _i = 0, _a = this.onProgressHandlers; _i < _a.length; _i++) {
            var handler = _a[_i];
            try {
                handler.call(this, progress);
            }
            catch (e) {
                console.error(e);
            }
        }
    };
    GCSResumableUpload.prototype.onStateChange = function (handler) {
        this.onStateChangeHandlers.push(handler);
    };
    GCSResumableUpload.prototype.fireNewState = function (newState) {
        var finalState = ["CANCELLED", "FAILED", "SUCCESSFUL"];
        if (finalState.indexOf(this.currentState) !== -1) {
            return; // Already in final state, this prevents backoff state after cancelled
        }
        if (this.currentState !== newState) {
            this.currentState = newState;
            for (var _i = 0, _a = this.onStateChangeHandlers; _i < _a.length; _i++) {
                var handler = _a[_i];
                try {
                    handler.call(this, newState);
                }
                catch (e) {
                    console.error(e);
                }
            }
        }
    };
    return GCSResumableUpload;
}());
export { GCSResumableUpload };
